class Fan{
  PFont fontL;
  int power = 0;
  int x,y;
  int num;
  int tempPower = power;
  int multiplik = 1;
  String name = "";
  /////////////////////////////////////////
  Fan(int i){
    fontL = loadFont("LevenimMTBold-48.vlw");
    num = i+1;
    x = width-450+(30*i);
    y = height-120;
    ///////////////
    if((num == 1) || (num == 3) || (num == 4) || (num == 6) || (num == 8) || (num == 9) || (num == 11) || (num == 13) || (num == 15)){
      multiplik = 5;
    }
    ///////////////
    serialSend();
  }
  //////////////////////////////////////////
  void draw(){
    anti();
    ///////////////////
    noFill();
    stroke(255);
    ellipse(x+5,y-5-power*5,8,8);
    noSmooth();
    line(x+5,y-power*5,x+5,y);
    ////////////////
    for (int u=0;u<25;u++){
      noStroke();
      fill(0+(u*10));
      rect(x+5,y+25-u,1,1);
    }
    smooth();
    //////////////
    fill(255);
    textFont(fontL, 12);
    text(power,x,y+50);
    if(multiplik != 1) text("*",x+15,y+50);
    //////////////
    if(name != null){
      pushMatrix();
      translate(x+7, y-(power*5)-20);
      rotate(radians(-90));
      textFont(fontC, 12);
      text(name,0,0);
      popMatrix(); 
    }
  }
  //////////////////////////////////////////
  ///////////////////////////////////////////
  void serialSend(){
    if(serialOn){
      if(power != tempPower){
        anti();
        gui.serialColor = color (0,200,40);
        port.write(255);
        port.write(num);
        port.write((power*multiplik));
        println("Fan : "+num+" = "+power*int(love)*multiplik);
        /////////////////
        tempPower = power;
      }
    }
  }
  ////////////////////////////////////////
  void anti(){
    // ventilo special
    if(power <= 0) power = 0;
    if(power >= 100) power = 100;
  }
}
