class Metar{
  String myName;
  int myNum;
  String[] data;
  String[] windData = new String [4]; // [0] = Wind Orientation in // [1] = Wind Speed in Kt // [2] = Wind Fluctuation in Kt;
  ////////////////////////
  String[] lat_long = new String [2];  // [0] = Latitude = PosY  // [1] = Longitude = PosY; 
  String[] myUTC = new String [5]; // [0] = Year  // [1] = Month  // [2] = Day  // [3] Hours  // [4] = Minutes ;
  String txtName = "";
  float posX,posY;
  color couleur = color(255,0,0);
  boolean anim = false;
  boolean refreshi = false;
  boolean asking = false;
  float taille = 0;
  int strokeCercle = 2;
  ////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////
  //////////////////////////////////////////INITIALISATION DE LA CLASS///////////////////////////////////////////////////////
  Metar(String[] info, String name, int num){
    data = info;
    myNum = num;
    myName = name;
    /////////////////////////////////////////////////////////////
    try{
      coordonnes();
      myName();
      ///////////////
      posX *= float(lat_long[1]);
      posY *= float(lat_long[0]);
      draw();
      //println(num+"is load "+name);
    }
    catch(Exception x){
      //dataFailded(myName);
    }
  }
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  void draw(){
    try{
      noStroke();
      stroke(couleur);
      fill(couleur);
      rect((width/2)+(posX*facteurTaille)+depMapX,(height/2)+(posY*facteurTaille)-50+depMapY,1,1);
      //////////////
      if(anim == true){
        stroke(couleur,255-(taille));
        strokeWeight(strokeCercle);
        noFill();
        ellipse((width/2)+(posX*facteurTaille)+depMapX,(height/2)+(posY*facteurTaille)-50+depMapY,taille,taille);
        strokeWeight(1);
        /////////////////////////////////
        taille += 1;
        if(taille>250){
          taille = 0;
          anim = false;
        }
      }
      //////////////////////
      if((mouseX > ((width/2)+(posX*facteurTaille)-2+depMapX)) && (mouseX < ((width/2)+(posX*facteurTaille)+2+depMapX)) && (mouseY > ((height/2)+(posY*facteurTaille)-50-2+depMapY)) && (mouseY < ((height/2)+(posY*facteurTaille)-50+2+depMapY))){
        fill(255);
        textFont(fontC, 12);
        if(refreshi){
          anim = true;
          for(int i = 0; i<data.length-2; i++){
            text(data[i],(width/2)+(posX*facteurTaille)+depMapX,(height/2)+(posY*facteurTaille)-50+depMapY+(12*i));
          }
        }
        else{
          if(data != null)
            text(data[0],(width/2)+(posX*facteurTaille)+depMapX,(height/2)+(posY*facteurTaille)-50+depMapY);
        }
        /////////////////////////
        if (mousePressed){
          if(asking == false){
            if(nbrequest < maxrequest){
              couleur = color (0,200,50);
              strokeCercle = 3;
              if(nbrequest == 0){
                requestList[nbrequest] = str(myNum);
                udp.send(str(myNum), "localhost", 7000);
                nbrequest++;
              }
              else{
                requestList[nbrequest] = str(myNum);
                nbrequest++;
              }
              asking = true;
              //println("NetWork List Request for "+myNum);
              statut = "> NetWork Request for "+(myNum)+" = "+myName;
              gui.time = 0;
            }
          }
        }
      }
    }    
    catch(Exception x){
      println("Exception Draw : "+myName+" : " + x);
    }
  }
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  void refreshData(){
    try{
      myName();
      ///////////////////////
      //http://www.weather.gov/xml/current_obs/Name.xml
      data = loadStrings("metar/"+myName+".txt");
      //////////////////////
      info = data;
      windDataFunction();
      curentWind = int(windData[1]);
      ////////////////////
      couleur = color(255);
      anim = true;
      refreshi = true;
      ///////////////////
      orientation = int (windData[0]);
      vitesse = int (windData[1]);
      //for(int i=0;i<nblife2;i++){
      //life2[i].orientation = int (windData[0]);
      //life2[i].vitesse = int (windData[1]);
      //}
      /////////////////////////////////
      if(gui.mode){
        for(int i=14 ; i > 0 ; i--){
          fan[i].power = fan[i-1].power;
          fan[i].name = fan[i-1].name;
        }
        fan[0].power = curentWind*int(love);
        fan[0].name = txtName;
      }
      else{
        fan[refeshFanStation].name = txtName;
        fan[refeshFanStation].power = curentWind*int(love);
        refeshFanStation++;
        if(refeshFanStation == 15) refeshFanStation = 0;
      }
      /////////////////////////////////////
      if(asking){
        statut = ("> Network Refreshed Station   code : "+myNum+" or "+myName);
        strokeCercle = 5;
        couleur = color (0,255,40);
        gui.time = 0;
        for(int i = 0; i < nbrequest+1; i++){
          if(requestList[i].equals(str(myNum))){
            for(int t = i; t < nbrequest+1; t++){
              requestList[t] = requestList[t+1];
            }
            nbrequest--;
          }
          if(requestList[i] == null){
            break;
          }
        }
      }
    }
    catch(Exception x){
    }
  }
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  void windDataFunction(){
    if(data[2].charAt(0) == 'W'){
      String tempDataLine = data[(data.length)-2];
      String tempData [] = split(tempDataLine);
      String temp_windData = tempData[3];
      ///////////////// exeption dans la chaine d'info.... c bien chiant.... !!!
      if((tempData[3].equals("AUTO") == true) || (tempData[3].equals("COR") == true) || (tempData[3].equals("RTD") == true)) {
        temp_windData = tempData[4];
      }
      ////////////////////////////////////////////////////////
      ///////////////////////////////////////////////////////
      ////////// Split DataWind into [] ////////////////////
      if(temp_windData.length() > 9){
        /// Fluctuation in Data
        windData[0] = ""+temp_windData.charAt(0);
        windData[0] += temp_windData.charAt(1);
        windData[0] += temp_windData.charAt(2);
        //
        windData[1] = ""+temp_windData.charAt(3);
        windData[1] += temp_windData.charAt(4);
        //
        windData[2] = ""+temp_windData.charAt(6);
        windData[2] += temp_windData.charAt(7);
      }
      else if(temp_windData.charAt(0) == 'V'){
        /// Variable at 1 MPH (1 KT):0
        windData[0] = "0";
        windData[1] = ""+temp_windData.charAt(3);
        windData[1] += temp_windData.charAt(4);
        windData[2] = "0";
      }
      else{
        /// Normal Data
        windData[0] = ""+temp_windData.charAt(0);
        windData[0] += temp_windData.charAt(1);
        windData[0] += temp_windData.charAt(2);
        //
        windData[1] = ""+temp_windData.charAt(3);
        windData[1] += temp_windData.charAt(4);
        //
        windData[2] = "0";
      }
    }
  }
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  void myName(){
    txtName = "";
    for(int i=0; i<data[0].length()-1; i++){
      char lettre = data[0].charAt(i);
      if(lettre == '(')break;
      txtName += lettre;
    }
  }
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  void coordonnes(){
    ////////////////////////////Analyse de la Latitude & Longitude////////////////////////////////
    String tempPosition = data[0];
    lat_long[0] = "";
    lat_long[1] = "";
    int nbtiret = 0;
    int step = 0;
    /////////////////////////////////////////////////////////////////////////
    for(int c=0; c<tempPosition.length(); c++){
      char lettre = tempPosition.charAt(c);
      if(lettre == ')'){
        for(int i=c+2; i<tempPosition.length(); i++){
          lettre = tempPosition.charAt(i);
          /////////////////////////////////////////////////
          if (step < 2){
            if(lettre == '-'){
              if(nbtiret == 0){
                lat_long[step] += ".";
                i++;
                nbtiret++;
              }
              else if (nbtiret > 0){
                lat_long[step] += "";
                nbtiret++;
                i++;
              }
            }
            /////////////////////////////////////////////////
            if(step == 0){
              lettre = tempPosition.charAt(i);
              if(lettre == 'N'){
                posY = -1;
                step++;
                i+=2;
                nbtiret = 0;
              }
              else if(lettre == 'S'){
                posY = 1;
                step++;
                i+=2;
                nbtiret = 0;
              }
              else {
                lat_long[0] += lettre;
              }
            }
            ///////////////////////////////////////////////
            if(step == 1){
              lettre = tempPosition.charAt(i);
              if(lettre == 'E'){
                posX = 1;
                step++;
                i++;
              }
              else if(lettre == 'W'){
                posX = -1;
                step++;
                i++;
              }
              else {
                lat_long[1] += lettre;
              }
            }
            ////////////////////////////////////////////////
          }
        }
      }
    }
  }
}
